﻿<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>TP2</title>
  <link rel="stylesheet" href="https://stackedit.io/style.css" />
</head>

<body class="stackedit">
  <div class="stackedit__html"><h1 id="tp2--vérification-des-acquis">TP2 : Vérification des acquis</h1>
<p>Vous avez normalement appris à créer un programme avec des boucles, des accès en mémoire en lecture et écriture, ainsi qu’avec des sauts vers des routines. Le but de ce TP est d’évaluer ces acquis.</p>
<blockquote>
<p>Le livrable attendu pour ce TP est une archive zip contenant un document par balise “<strong>Livrable attendu</strong>” dans le TP<br>
Chaque livrable sera nommé selon la consigne de la balise<br>
Le TP doit être fait par binôme, MAIS chaque élève du binôme doit le rendre sur le moodle.<br>
Les deux noms doivent apparaitre sur chacune des copie. L’archive devra être intitulée nom1_nom2_tp2.zip</p>
</blockquote>
<h2 id="comprendre-10-points">1. Comprendre (10 points)</h2>
<p>Soit le programme suivant :</p>
<pre><code>.orig x3000
LD R0, x16
LD R1, x16
ST R0, x11
ST R0, x11
ADD R1, R1, #-1
JSR x06
LD R2, x0F
ST R2, x0C
ADD R1, R1, #-1
BRP #-5
ST R2, x0E
TRAP x25
AND R3, R3, #0
LD R4, x06
LD R5, x06
ADD R3, R3, R4
ADD R5, R5, #-1
BRP #-3
ST R3, x03
RET
.blkw #1
.blkw #1
.blkw #1
.fill #3
.fill #3
.blkw #1
.END
</code></pre>
<h3 id="a.-code-machine-4-points">1.A. Code machine (4 points)</h3>
<p>Décrivez les valeurs chargées en mémoire suite à l’interprétation de ce code. à savoir, donnez les valeurs <strong>en binaire</strong> contenues dans chacune des cases de l’adresse x3000 à l’adresse x3019 (avant que le programme ne soit exécuté)</p>
<p><strong>Respectez le format xxxx xxxx xxxx xxxx (e.g. 0100 1101 0110 1111)</strong></p>
<p><strong>e.g.<br>
x3000 : 0100 1101 0110 1111<br>
x3001 : 0000 1101 0110 1110<br>
…</strong></p>
<h3 id="b.-pc-4-points">1.B. PC (4 points)</h3>
<p>Donner les 44 première valeurs prises successivement par le registre <code>Compteur ordinal</code>, à partir de son initialisation à la valeur x3000</p>
<p><strong>e.g.<br>
x3000<br>
x3006<br>
x3001<br>
…</strong></p>
<h3 id="c.-traduction-2-points">1.C. Traduction (2 points)</h3>
<p>Décrire en une ligne quel est le but de ce programme</p>
<blockquote>
<p>Pour 1.A, 1.B et 1.C<br>
<strong>Livrable attendu</strong> : un fichier texte avec les réponses aux questions a, b et c<br>
Le livrable sera nommé ex1_tp2_nom1_nom2.txt</p>
</blockquote>
<h2 id="créer-20-points">2. Créer (20 points)</h2>
<h3 id="a.-la-fonction-max-5-points">2.A. La fonction Max (5 points)</h3>
<p>Une fonction max est une routine permettant de retourner le maximum de deux nombres passés en arguments.<br>
Une version possible de cette fonction peut s’imaginer ainsi :<br>
On retourne <strong>VRAI</strong> si le seconde argument est la plus grande des deux valeurs, sinon on retourne <strong>FAUX</strong>, ce qui donne en pseudo-code :</p>
<pre><code>fonction max(valeur1, valeur2)
	Si valeur1 &lt; valeur2
		retourner VRAI
	Sinon
		retourner FAUX
	fin si
</code></pre>
<p>De manière primitive, la valeur <strong>VRAI</strong> peut se représenter par un <strong>1</strong> et <strong>FAUX</strong> par un <strong>0</strong></p>
<p>On propose de squelette suivant d’assembleur LC-3 pour implémenter la routine Max :</p>
<pre><code>.orig x3000
;####################### func_max #######################
;## calcule RESULATm = 0 si VALEUR1m &gt;= VALEUR2m       ##
;##	        RESULATm = 1 si VALEUR1m &lt;  VALEUR2m       ##
;########################################################
FUNC_MAX ;LABEL alias d'adresse de la première instruction de la fonction func_max 

;[votre code ici]

;espace mémoire func_max
VALEUR1m .blkw #1 ; La directive '.blkw n' résèrve n block de mémoire
VALEUR2m .blkw #1
RESULTATm .blkw #1

.END
</code></pre>
<blockquote>
<p>Rappel : Sur une ligne, si le caractère ‘;’ est présent, le reste de la ligne après ce caractère est un commentaire et n’est ni une <em>directive</em>, ni une <em>instruction</em></p>
</blockquote>
<p><strong>Complétez le code avec les instructions permettant stocker <strong>1</strong> dans <code>RESULTATm</code> si <code>VALEUR1m</code> &lt; <code>VALEUR2m</code>, et <strong>0</strong> sinon.</strong></p>
<blockquote>
<p>Rappel : Le LC-3 est basé sur une architecture Load/Store. Pour manipuler une valeur stockée en mémoire (La valeur à l’adresse VALEUR1m par exemple), il faut d’abord la charger dans un registre (<strong>Load</strong>) et après stocker le résultat dans la mémoire (<strong>store</strong>)</p>
</blockquote>
<blockquote>
<p>Rappel : Pour comparer deux valeurs, vous pouvez vérifier le résultat de la soustraction de ces deux valeurs.</p>
</blockquote>
<blockquote>
<p><strong>Livrable attendu</strong> : Un code en assembleur LC-3 commenté et fonctionnel dans le simulateur <a href="https://wchargin.com/lc3web/">LC-3 Simulator (wchargin.com)</a><br>
Le code doit être commenté (sinon pénalité)<br>
Le livrable sera nommé ex2_a_tp2_nom1_nom2.txt</p>
</blockquote>
<h3 id="b.-appel-de-la-routine-5-points">2.B. Appel de la routine (5 points)</h3>
<p>Nous voulons faire en sorte d’appeler la routine<code>func_max</code> depuis une autre routine.</p>
<p>Ci-dessous un squelette de code :</p>
<pre><code>.orig x3000

;####################### func_autre #####################
;##                  Mon autre fonction                ##
;########################################################
FUNC_AUTRE ;LABEL alias d'adresse de la première instruction de la fonction func_autre

;[votre code ici]

HALT ; Arrêter l'execution ici

;####################### func_max #######################
;## calcule RESULATm = 0 si VALEUR1m &gt;= VALEUR2m       ##
;##	        RESULATm = 1 si VALEUR1m &lt;  VALEUR2m       ##
;########################################################
FUNC_MAX ;LABEL alias d'adresse de la première instruction de la fonction func_max 
;[ma fonction func_max]

;espace mémoire variables func_max
VALEUR1m .blkw #1 ; La directive '.blkw n' résèrve n block de mémoire
VALEUR2m .blkw #1
RESULTATm .blkw #1

;espace mémoire variables func_autre
VALEUR1a .fill #25
VALEUR2a .fill #10
RESULTATa .blkw #1

.END
</code></pre>
<p>Pour ce second exercice, vous devez vérifier si <code>VALEUR1a</code> est inférieur ou supérieur à <code>VALEUR2a</code>.  Vous devez, pour cela, appeler la routine <code>func_max</code> depuis la routine <code>func_autre</code>, après avoir chargé les valeurs de <code>func_autre</code> dans les cases mémoires utilisées par <code>func_max</code></p>
<blockquote>
<p>Rappel : Vous devez utiliser les instructions <strong>JSR</strong> dans la fonction appelante et <strong>RET</strong> dans la fonction appelée. N’oubliez pas de relire le manuel de référence de l’ISA LC-3</p>
</blockquote>
<blockquote>
<p><strong>Livrable attendu</strong> : Un code en assembleur LC-3 commenté et fonctionnel dans le simulateur <a href="https://wchargin.com/lc3web/">LC-3 Simulator (wchargin.com)</a><br>
Le code doit être commenté (sinon pénalité)<br>
Le livrable sera nommé ex2_b_tp2_nom1_nom2.txt</p>
</blockquote>
<h3 id="c.-usage-concret-5-points">2.C. Usage concret (5 points)</h3>
<p>L’algorithme de tri par insertion est le plus trivial des algorithmes de tri. Ci-dessous le pseudo-code de cet algorithme :</p>
<pre><code>i = 1
tant que i &lt; longueur(Tableau)
    j = i
    tant que j &gt; 0 et Tableau[j-1] &gt; Tableau[j]
        échanger Tableau[j] et Tableau[j-1]
        j = j - 1
    fin tant que
    i = i + 1
fin tant que
</code></pre>
<p>Cet algorithme permet de trier un tableau.</p>
<h4 id="c.1.-parcourir-le-tableau-1-points">2.C.1. Parcourir le tableau (1 points)</h4>
<p>La première étape est de correctement parcourir les éléments du tableau afin de les ordonner</p>
<p>Ci-dessous, une série d’instruction permettant de parcourir un tableau qui commence à l’adresse dont l’alias est le label TABLEAU :</p>
<pre><code>.orig x3000

LEA R1, TABLEAU ; On charge l'adresse d'une case du tableau (ici la première case)
AND R2, R2, #0 ; On initialise un registre pour tenir le compte des cases parcourues

LD R3, TAILLE_TABLEAU ; On charge la taille de tableau pour la comparer au compteur
NOT R3, R3 ; On l'inverse
ADD R3, R3, #1 ; On Complémente

BOUCLE_TABLEAU ADD R4, R2, R3 ; première instruction de la boucle au label BOUCLE_TABLEAU
BRZP FIN; On compare et on sort si la fin du tableau est atteinte
LDR R0, R1, #0 ; On charge la valeur de la case courante du  TABLEAU dans R0
ADD R1, R1, #1 ; On incrémente l'adresse de la case courante
ADD R2, R2, #1 ; On incrémente le compteur de cases visitées
BRNZP BOUCLE_TABLEAU ; On boucle de manière inconditionnel

FIN HALT ; Instruction HALT au label FIN

ADRESSE_TABLEAU_I .blkw #1
COMPTEUR_PARCOURU_I .blkw #1
TAILLE_TABLEAU .fill #10
TABLEAU .fill #6
.fill #3
.fill #7
.fill #2
.fill #8
.fill #3
.fill #9
.fill #23
.fill #2
.fill #13

.END
</code></pre>
<p>Maintenant, voici le nouveau besoin</p>
<p>Vous avez le tableau suivant :<br>
6 | 3 | 7 | 2 | 8 | 3 | 9 | 23 | 2 | 13<br>
Vous devez parcourir les éléments du tableau de la manière suivante :<br>
6, 3, 6, 7, 3, 6, 2, 7, 3, 6, 8, 2, 7, 3, 4, …</p>
<p>Modifiez la boucle fournie pour parcourir les éléments selon la manière décrite : <strong>Il faudra que le programme stocke la valeur courante visitée dans le registre R0 (R0 devra donc valoir à tour de rôle 6 puis 3 puis 6, etc.)</strong></p>
<blockquote>
<p>Astuce : il s’agit d’un cas d’emploi d’une boucle dans une boucle (inspirez-vous du pseudo-code de l’algorithme de tri par insertion)</p>
</blockquote>
<blockquote>
<p>Rappel : Si vous n’avez pas assez de registre pour retenir toutes les valeurs nécessaires, vous pouvez réserver une case mémoire et stocker/charger la valeur dans cette case mémoire. Exemple :</p>
<pre><code>AND R0, R0, #0 ; On reset le registre
ADD R0, R0, #10 ; On y charge une valeur
ST R0, MA_CASE_MEMOIRE ; On sauvegarde la valeur
; [...]
; D'autres instructions
; [...]
LD R0, MA_CASE_MEMOIRE ; On recharge la valeur

MA_CASE_MEMOIRE .blkw #1
</code></pre>
</blockquote>
<blockquote>
<p><strong>Livrable attendu</strong> : Un code en assembleur LC-3 commenté et fonctionnel dans le simulateur <a href="https://wchargin.com/lc3web/">LC-3 Simulator (wchargin.com)</a><br>
Le code doit être commenté (sinon pénalité)<br>
Le livrable sera nommé ex2_c1_tp2_nom1_nom2.txt</p>
</blockquote>
<h4 id="c.2.-échanger-deux-valeurs-de-place-2-points">2.C.2. Échanger deux valeurs de place (2 Points)</h4>
<p>Les instructions suivantes forment une routine permettant d’échanger deux valeurs de cases mémoires d’un tableau :</p>
<pre><code>.orig x3000

LEA R2, TABLEAU ; On charge l'adresse de la première case du TABLEAU

LDR R0, R2, #0 ; On charge la valeur de la première case du TABLEAU
LDR R1, R2, #1 ; On charge la valeur de la case voisine
STR R0, R2, #1 ; On interchange les deux valeurs 
STR R1, R2, #0
HALT

TABLEAU .fill #6
.fill #3

.END
</code></pre>
<p>Vous avez le tableau suivant :<br>
6 | 3 | 7 | 2 | 8 | 3 | 9 | 23 | 2 | 13<br>
Vous devez créer le nouveau tableau suivant :<br>
3 | 7 | 2 | 8 | 3 | 9 | 23 | 2 | 13 | 6</p>
<p><strong>Il faut que votre programme modifie le tableau existant</strong></p>
<p>Appuyez-vous sur le squelette suivant :</p>
<pre><code>.orig x3000

;[Votre code ici]

HALT

ADRESSE_TABLEAU_I .blkw #1
COMPTEUR_PARCOURU_I .blkw #1
TAILLE_TABLEAU .fill #10
TABLEAU .fill #6
.fill #3
.fill #7
.fill #2
.fill #8
.fill #3
.fill #9
.fill #23
.fill #2
.fill #13

.END
</code></pre>
<blockquote>
<p><strong>Livrable attendu</strong> : Un code en assembleur LC-3 commenté et fonctionnel dans le simulateur <a href="https://wchargin.com/lc3web/">LC-3 Simulator (wchargin.com)</a><br>
Le code doit être commenté (sinon pénalité)<br>
Le livrable sera nommé ex2_c2_tp2_nom1_nom2.txt</p>
</blockquote>
<h4 id="c.3.-comparer-et-ordonner-2-points">2.C.3. Comparer et ordonner (2 Points)</h4>
<p>Combinez tout ce qui a été vu pour mettre en œuvre l’algorithme de tri par insertion en assembleur LC-3. Triez le tableau dans l’ordre croissant.</p>
<p><strong>Le tableau composé des cases mémoires successives après le Label <code>TABLEAU</code> devra être ordonné par votre programme</strong></p>
<p>Appuyez-vous sur le squelette ci-dessous :</p>
<pre><code>.orig x3000

;####################### func_sort #####################
;##            trie les éléments de TABLEAU           ##
;#######################################################
FUNC_SORT ;LABEL alias d'adresse de la première instruction de la fonction func_sort
;[votre code ici]

HALT ; Arrêter l'execution ici

;####################### func_max #######################
;## calcule RESULATm = 0 si VALEUR1m &gt;= VALEUR2m       ##
;##	        RESULATm = 1 si VALEUR1m &lt;  VALEUR2m       ##
;########################################################
FUNC_MAX ;LABEL alias d'adresse de la première instruction de la fonction func_max 
;[ma fonction func_max]

;espace mémoire func_max
VALEUR1m .blkw #1
VALEUR2m .blkw #1
RESULTATm .blkw #1

;espace mémoire func_sort
ADRESSE_TABLEAU_I .blkw #1
ADRESSE_TABLEAU_J .blkw #1
COMPTEUR_PARCOURU_I .blkw #1
COMPTEUR_PARCOURU_J .blkw #1
TAILLE_TABLEAU .fill #10
TABLEAU .fill #6
.fill #3
.fill #7
.fill #2
.fill #8
.fill #3
.fill #9
.fill #23
.fill #2
.fill #13

.END
</code></pre>
<p>Vous avez le tableau suivant :<br>
6 | 3 | 7 | 2 | 8 | 3 | 9 | 23 | 2 | 13<br>
Vous devez créer le nouveau tableau suivant :<br>
2 | 2 | 3 | 3 | 6 | 7 | 8 | 9 | 13 | 23</p>
<blockquote>
<p><strong>Livrable attendu</strong> : Un code en assembleur LC-3 commenté et fonctionnel dans le simulateur <a href="https://wchargin.com/lc3web/">LC-3 Simulator (wchargin.com)</a><br>
Le code doit être commenté (sinon pénalité)<br>
Le livrable sera nommé ex2_c3_tp2_nom1_nom2.txt</p>
</blockquote>
<h3 id="d.-avec-une-runtime-stack-5-points">2.D. Avec une runtime stack (5 points)</h3>

<table>
<thead>
<tr>
<th align="center">Runtime Stack</th>
</tr>
</thead>
<tbody>
<tr>
<td align="center">…</td>
</tr>
<tr>
<td align="center">Variable locale n</td>
</tr>
<tr>
<td align="center">…</td>
</tr>
<tr>
<td align="center">Variable locale 0</td>
</tr>
<tr>
<td align="center">PC sauvegardé</td>
</tr>
<tr>
<td align="center">Valeur de retour</td>
</tr>
<tr>
<td align="center">Argument n</td>
</tr>
<tr>
<td align="center">…</td>
</tr>
<tr>
<td align="center">Argument 0</td>
</tr>
<tr>
<td align="center">…</td>
</tr>
</tbody>
</table><p>Souvenez vous que si R6 pointe le haut de la pile (Stack pointer):</p>
<ul>
<li>Pour initialiser sa valeur à l’adresse pointée par un label (e.g. <code>STACKSTART</code>)<pre><code> LEA R6, STACKSTART
</code></pre>
</li>
<li>Pour pousser le contenu du registre Rx sur la stack<pre><code>STR Rx, R6, #0
ADD R6, R6, #-1
</code></pre>
</li>
<li>Pour écrire le contenu du haut de la stack dans le registre Rx<pre><code>LDR Rx, R6, #1
ADD R6, R6, #1
</code></pre>
</li>
</ul>
<p>En prenant le squelette de code modifié, ci-dessous, ainsi que vos connaissance sur le principe de fonctionnement de la runtime stack, modifié votre code pour stocker arguments, les valeurs de retour et les variable locales sur la stack.</p>
<pre><code>.orig x3000

;####################### func_sort #####################
;##            trie les éléments de TABLEAU           ##
;#######################################################
FUNC_SORT LEA R6, STACKSTART ;LABEL alias d'adresse de la première instruction de la fonction func_sort
;[votre code ici]

HALT ; Arrêter l'execution ici

;####################### func_max #######################
;## calcule RESULATm = 0 si VALEUR1m &gt;= VALEUR2m       ##
;##	        RESULATm = 1 si VALEUR1m &lt;  VALEUR2m       ##
;########################################################
FUNC_MAX ;LABEL alias d'adresse de la première instruction de la fonction func_max 
;[ma fonction func_max]


TABLEAU .fill #6
.fill #3
.fill #7
.fill #2
.fill #8
.fill #3
.fill #9
.fill #23
.fill #2
.fill #13

MAXSTACK .BLKW #199
STACKSTART .fill #0

.END
</code></pre>
<blockquote>
<p><strong>Livrable attendu</strong> : Un code en assembleur LC-3 commenté et fonctionnel dans le simulateur <a href="https://wchargin.com/lc3web/">LC-3 Simulator (wchargin.com)</a><br>
Le code doit être commenté (sinon pénalité)<br>
Le livrable sera nommé ex2_d_tp2_nom1_nom2.txt</p>
</blockquote>
<h2 id="hacker-10-points">3. Hacker (10 points)</h2>
<blockquote>
<h2 id="setup-">Setup :</h2>
<p>Dans le simulateur LC-3 <a href="https://wchargin.com/lc3web/">LC-3 Simulator (wchargin.com)</a> :<br>
En utilisant le bouton <em><strong>upload</strong></em> (rond avec la flèche, à côté de <code>Assemble</code>)</p>
<ul>
<li>charger le fichier <code>TP2_hacker.obj</code></li>
</ul>
</blockquote>
<p>Le programme ainsi chargé en mémoire du LC-3 attend un texte dans la console, terminé par la touche <code>entrée</code><br>
Si tout se passe bien, l’exécution du programme se termine par le texte “not hacked” dans la console.</p>
<p>Je vous laisse essayer avec le texte “a”</p>
<p>Si tout ne se passe pas bien, le programme plante et aucun texte ne s’affiche.<br>
<strong>Mais de manière plus intéressante, avec certaines entrées dans la console bien choisies, le programme affiche "hacked"</strong></p>
<p>Trouvez la forme minimale de cette entrée et expliquez en quelques mots le principe derrière cet exploit</p>
<blockquote>
<p><strong>Livrable attendu</strong> : Un fichier texte simple (pas docx, pdf ou autre)<br>
Devra contenir l’entrée minimale trouvée ainsi que les quelques mots d’explications<br>
Le livrable sera nommé ex3_tp2_nom1_nom2.txt</p>
</blockquote>
</div>
</body>

</html>
